Unit ftfsr_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ftfsr(var X :Array of Real; N :Integer);

implementation

procedure ftfsr(var X :Array of Real; N :Integer);
var
CGI,I1C,I1I,I1O,ICI,O11,OII,OO1,OOI :Integer;
CG1,G1C,GIC,I01,I11,IC1,IGI,II1,IIC,III,O00,O01,O0I,O0O,O10,OI0,
OO0,OOO :Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
SYS029 :Real = 0.70710678118654752440084436210485;
label
_10,_20,_30,_40,_50,_60,_70,_80,_23,_90,_100,_110;
begin
II1 := SYS001;
CG1 := SYS029;
X[0] := 0.0;
I1C := Abs(N);
if ( I1C = 4 ) 
 then goto _100;
if ( I1C <= 2 ) 
 then goto _110;
I1I := Trunc( (3 + IntSign(1,N))/2 );
I1O := Trunc( I1C/2 );
ICI := Trunc( I1O/2 );
O0I := II1/(I1C);
CGI := I1O + 1;
OII := CGI;
OO1 := I1C;
O0O := Cos(O0I);
O01 := Sin(O0I);
IC1 := 1.0;
GIC := 0.0;
for OOI:=2 to ICI do
 begin
  case I1I of
   1: goto _10;
   2: goto _20;
  end;
_10:
  O00 := O0I*(OOI - 1);
  GIC := Sin(O00);
  IC1 := Cos(O00);
  goto _30;
_20:
  OO0 := IC1*O0O - GIC*O01;
  GIC := IC1*O01 + GIC*O0O;
  IC1 := OO0;
_30:
  OII := OII - 1;
  CGI := CGI + 1;
  I01 := X[OOI-1];
  III := X[OO1-1];
  O10 := (I01 + III)*GIC;
  IIC := I01 - III;
  X[OOI-1] := O10 - IIC;
  X[OO1-1] := O10 + IIC;
  I01 := X[OII-1];
  III := X[CGI-1];
  O10 := (I01 + III)*IC1;
  IIC := I01 - III;
  X[OII-1] := O10 - IIC;
  X[CGI-1] := O10 + IIC;
  OO1 := OO1 - 1;
_40:
 end;
I01 := X[ICI+0];
III := X[3*ICI+0];
O10 := (I01 + III)*CG1;
IIC := I01 - III;
X[ICI+0] := O10 - IIC;
X[3*ICI+0] := O10 + IIC;
X[I1O+0] := 2.0*X[I1O+0];
OOO := 1.0;
FTF1C(X[0],X[1],I1C,1,2,OOO);
CGI := I1O + 4;
OII := I1O;
OO1 := I1C;
O0O := Cos(2.0*O0I);
O01 := Sin(2.0*O0I);
IC1 := 1.0;
GIC := 0.0;
if ( N = 8 ) 
 then goto _23;
OOI := 4;
while ( OOI<=ICI ) do
 begin
  case I1I of
   1: goto _50;
   2: goto _60;
  end;
_50:
  O00 := O0I*(OOI - 2);
  IC1 := Cos(O00);
  GIC := Sin(O00);
  goto _70;
_60:
  OO0 := IC1*O0O - GIC*O01;
  GIC := IC1*O01 + GIC*O0O;
  IC1 := OO0;
_70:
  I01 := X[OOI-2];
  III := X[OO1-2];
  O10 := X[OOI-1];
  IIC := X[OO1-1];
  G1C := O10 + IIC;
  OI0 := III - I01;
  I11 := OI0*IC1 - G1C*GIC;
  IGI := O10 - IIC;
  X[OOI-2] := (I11 + IGI)*0.25;
  X[OO1-2] := (I11 - IGI)*0.25;
  I11 := OI0*GIC + G1C*IC1;
  IGI := I01 + III;
  X[OO1-1] := IGI - I11;
  X[OOI-1] := IGI + I11;
  I01 := X[OII-2];
  III := X[CGI-2];
  O10 := X[OII-1];
  IIC := X[CGI-1];
  G1C := O10 + IIC;
  OI0 := III - I01;
  I11 := OI0*GIC - G1C*IC1;
  IGI := O10 - IIC;
  X[OII-2] := (I11 + IGI)*0.25;
  X[CGI-2] := (I11 - IGI)*0.25;
  I11 := OI0*IC1 + G1C*GIC;
  IGI := I01 + III;
  X[CGI-1] := IGI - I11;
  X[OII-1] := IGI + I11;
  OO1 := OO1 - 2;
  OII := OII - 2;
  CGI := CGI + 2;
_80:
  inc(OOI,2);
 end;
_23:
I01 := X[OII-2];
III := X[CGI-2];
O10 := X[OII-1];
IIC := X[CGI-1];
G1C := O10 + IIC;
OI0 := III - I01;
I11 := (OI0 - G1C)*CG1;
IGI := O10 - IIC;
X[OII-2] := (I11 + IGI)*0.25;
X[CGI-2] := (I11 - IGI)*0.25;
I11 := (OI0 + G1C)*CG1;
IGI := I01 + III;
X[CGI-1] := IGI - I11;
X[OII-1] := IGI + I11;
X[1] := (X[0] + X[1])*0.5;
X[0] := 0.0;
I01 := X[I1O+1]*0.5;
X[I1O+1] := X[I1O+0]*2.0;
X[I1O+0] := -I01;
O11 := 4;
while ( O11<=I1C ) do
 begin
  X[O11-1] := X[O11-3] + X[O11-1]*0.5;
_90:
  inc(O11,2);
 end;
goto _110;
_100:
I01 := (X[1] + X[3])*CG1;
III := X[2];
X[2] := X[1] - X[3];
X[1] := I01 + III;
X[3] := I01 - III;
_110:
end;

end.
